package org.mandarax.util.resultsetfilters;

/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.util.List;
import org.mandarax.kernel.InferenceException;
import org.mandarax.kernel.ResultSet;
 
/**
 * A utility class to create compund result set conditions.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 3.0
 */
public class ResultSetConditions  {

	/**
	 * Build a complex condition using AND.
	 * @param children a list of conditions
	 * @return a condition
	 */
	public static ResultSetCondition and(final List children) {
		return new ResultSetCondition() {
			// indicates whether the condition is satisfied
			public boolean isSatisfiedBy(ResultSet rs) throws InferenceException {
				for (int i=0;i<children.size();i++) {
					ResultSetCondition cond = (ResultSetCondition)children.get(i);
					if (!cond.isSatisfiedBy(rs)) return false;
				}
				return true;
			}			
		};		
	}
	/**
	 * Build a complex condition using OR.
	 * @param children a list of conditions
	 * @return a condition
	 */
	public static ResultSetCondition or(final List children) {
		return new ResultSetCondition() {
			// indicates whether the condition is satisfied
			public boolean isSatisfiedBy(ResultSet rs) throws InferenceException {
				for (int i=0;i<children.size();i++) {
					ResultSetCondition cond = (ResultSetCondition)children.get(i);
					if (cond.isSatisfiedBy(rs)) return true;
				}
				return false;
			}			
		};		
	}
	/**
	 * Build a complex condition using NOT.
	 * @param child a condition
	 * @return a condition
	 */
	public static ResultSetCondition not(final ResultSetCondition child) {
		return new ResultSetCondition() {
			// indicates whether the condition is satisfied
			public boolean isSatisfiedBy(ResultSet rs) throws InferenceException {
				return !child.isSatisfiedBy(rs);
			}			
		};		
	}
}
